#!/bin/bash -

ibench=$(basename $0)
perror() { echo "$@" 1>&2; }
fcalc() { awk "BEGIN { print $@ }"; }
#hash bc || { perror "Please install bc command."; exit 1; }
test -x fftwbench || { perror "Please 'make fftwbench'."; exit 1; }
test -x otfftbench || { perror "Please 'make otfftbench'."; exit 1; }

case $# in
    0) from=1; to=24; wisdom="wisdom";;
    1) from=$1; to=$1; wisdom="wisdom";;
    2) from=$1; to=$2; wisdom="wisdom";;
    3) from=$1; to=$2; wisdom="$3";;
    *) perror "usage: bash $ibench [from to [wisdom]]"; exit 1;;
esac

test -a "$wisdom" || { perror "'$wisdom' dose not exist."; exit 1; }

perror "[FFTW3]"
fftw_dat=$(./fftwbench $from $to $wisdom | tee /dev/stderr)
perror
perror "[OTFFT]"
otfft_dat=$(./otfftbench $from $to | tee /dev/stderr)
perror

echo "FFTW wisdom: import wisdom from '$wisdom'."
echo "------+-----------+-----------+-----------"
echo "length|FFTW3[usec]|OTFFT[usec]|OTFFT/FFTW3"
echo "------+-----------+-----------+-----------"
paste <(echo "$fftw_dat") <(echo "$otfft_dat") |\
    while read i x j y; do
        #z=$(echo "$y / $x * 100" | bc -l)
        z=$(fcalc "$y / $x * 100")
        case $i in
            cost)
                echo   "------+-----------+-----------+-----------"
                printf " cost |%11.2f|%11.2f|%10.0f%%\n" $x $y $z;;
            *)
                printf "2^(%2d)|%11.2f|%11.2f|%10.0f%%\n" $i $x $y $z;
        esac
    done
echo "------+-----------+-----------+-----------"
