#!/bin/bash -

makewisdom=$(basename $0)
highlight() { grep --color -e '.*'; }
if echo $LANG | grep -q ja_; then
    msg_install="Error: fftw-wisdom をインストールしてください。"
    msg_longtime="以下、非常に長い時間がかかります。お茶でもどうぞ。"
else
    msg_install="Error: Please install fftw-wisdom."
    msg_longtime="The following will take a very long time. Have a tea time."
fi

hash fftw-wisdom || { echo "$msg_install" | highlight; exit 1; }
test -n "$1" && wisdom="$1" || {
    echo
    echo "usage: bash $makewisdom wisdom_name"
    echo
    exit 1
}
date1=$(date +"%m/%d %H:%M")
echo
echo "start making FFTW wisdom file ..."
echo

s=1
n=$NUMBER_OF_PROCESSORS
echo "It is made with $n threads."
fftw-wisdom -n -m -T $s -v -o $wisdom cof$((2**1)) cob$((2**1))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**2)) cob$((2**2))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**3)) cob$((2**3))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**4)) cob$((2**4))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**5)) cob$((2**5))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**6)) cob$((2**6))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**7)) cob$((2**7))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**8)) cob$((2**8))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**9)) cob$((2**9))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**10)) cob$((2**10))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**11)) cob$((2**11))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**12)) cob$((2**12))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**13)) cob$((2**13))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**14)) cob$((2**14))
fftw-wisdom -n -m -T $s -v -o $wisdom -w $wisdom cof$((2**15)) cob$((2**15))
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**16)) cob$((2**16))
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**17)) cob$((2**17))
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**18)) cob$((2**18))
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**19)) cob$((2**19))
echo "$msg_longtime" | highlight
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**20)) cob$((2**20))
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**21)) cob$((2**21))
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**22)) cob$((2**22))
echo "CPU is cooling down. There are 4 plans left ..."; sleep 120
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**23)) cob$((2**23))
echo "CPU is cooling down. There are 2 plans left ..."; sleep 120
fftw-wisdom -n -m -T $n -v -o $wisdom -w $wisdom cof$((2**24)) cob$((2**24))
echo "CPU is cooling down ..."; sleep 120

echo
echo "FFTW wisdom file has been made."
echo
date2=$(date +"%m/%d %H:%M")
echo "It ran from $date1 to $date2."
