#!/bin/bash -

makewisdom=$(basename $0)
highlight() { grep --color -e '.*'; }
if echo $LANG | grep -q ja_; then
    msg_fftwbench="Error: fftwbench を make してください。"
    msg_confirmation="長い時間がかかります。実行しますか？[Y/n]: "
    msg_longtime="以下、非常に長い時間がかかります。お茶でもどうぞ。"
else
    msg_fftwbench="Error: Please 'make fftwbench'."
    msg_confirmation="It takes a long time. Do you want to run it? [Y/n]: "
    msg_longtime="The following will take a very long time. Have a tea time."
fi

test -x fftwbench || { echo "$msg_fftwbench" | highlight; exit 1; }
test -n "$1" && wisdom="$1" || {
    echo
    echo "usage: bash $makewisdom wisdom_name"
    echo
    exit 1
}

echo -en "\033[31m"
read -t 15 -n 1 -p "${msg_confirmation}" ans
echo -e "\033[m"
test "$ans" = "N" && exit 1
test "$ans" = "n" && exit 1

test -a $wisdom && {
    if test -a $wisdom.save; then
        echo "The '$wisdom.save' already exists." | highlight
        exit 1
    else
        mv $wisdom $wisdom.save
        echo "Old '$wisdom' is saved as '$wisdom.save'."
    fi
}

date1=$(date +"%m/%d %H:%M")
./fftwbench 1 21 $wisdom $wisdom
echo "$msg_longtime" | highlight
./fftwbench 22 22 $wisdom $wisdom
echo "CPU is cooling down ..."; sleep 120
./fftwbench 23 23 $wisdom $wisdom
echo "CPU is cooling down ..."; sleep 120
./fftwbench 24 24 $wisdom $wisdom
echo "CPU is cooling down ..."; sleep 120
date2=$(date +"%m/%d %H:%M")
echo "Done! It ran from $date1 to $date2."
