/******************************************************************************
*  Copyright (c) 2023 OK Ojisan(Takuya OKAHISA)
*  Released under the MIT license
*  http://opensource.org/licenses/mit-license.php
*******************************************************************************/

#ifndef useriomanip_h
#define useriomanip_h

#include <iostream>
#include <iomanip>

struct fd {
    const int n;
    const int x;
    fd(const int n, const int x) : n(n), x(x) {}
};
ostream& operator<<(ostream& os, const fd& f)
{
    os << setw(f.n) << f.x;
    return os;
}

struct ff {
    const int n;
    const int m;
    const double x;
    ff(const int n, const int m, const double x) : n(n), m(m), x(x) {}
};
ostream& operator<<(ostream& os, const ff& f)
{
    os << fixed << setw(f.n) << setprecision(f.m) << f.x;
    return os;
}

#endif // useriomanip_h
